## ponyprog 3.1.4%2Bds

=== distribution/osx/CMakeLists.txt ===
#OPTION(PONYPROG_INSTALL_AQSIS "Include Aqsis in the K-3D installer" OFF)
#OPTION(PONYPROG_INSTALL_CGKIT "Include cgkit in the K-3D installer" OFF)
#OPTION(PONYPROG_INSTALL_PYGTK "Include PyGTK in the K-3D installer" OFF)
#OPTION(PONYPROG_INSTALL_PYOPENGL "Include PyOpenGL in the K-3D installer" OFF)
#OPTION(PONYPROG_INSTALL_PYTHON "Include Python in the K-3D installer" ON)
OPTION(PONYPROG_CREATE_PACKAGEMAKER_PACKAGE "Include an option to build a MacOSX PackageMaker package." OFF)

SET(PONYPROG_BINARY_LOCATIONS )
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-make-module-proxy")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-renderframe")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-renderjob")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-resource-compiler")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-sl2xml")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-uuidgen")

FILE(GLOB_RECURSE PONYPROG_PLUGIN_BINARIES "${PONYPROG_BINARY_DIR}/${PONYPROG_LIBDIR}/ponyprog/plugins/*.module")
LIST(APPEND PONYPROG_BINARY_LOCATIONS ${PONYPROG_PLUGIN_BINARIES})

# Enable automatic installation of library dependencies ...
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/dependencies.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/dependencies.cmake" @ONLY)
INSTALL(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/dependencies.cmake")

# Install some runtime dependencies that can't be detected via static analysis ...

# This is an ugly hack, we should be able to detect this automatically, but I'm feeling lazy ...
SET(PONYPROG_MACPORTS_DIR "/opt/local" CACHE PATH "Root directory containing installed MacPorts packages")
MARK_AS_ADVANCED(PONYPROG_MACPORTS_DIR)

INSTALL(
	PROGRAMS
		${PONYPROG_MACPORTS_DIR}/lib/libgailutil.18.dylib
	DESTINATION
		lib
	)

INSTALL(
	DIRECTORY
		${PONYPROG_MACPORTS_DIR}/lib/gtk-2.0/2.10.0
	DESTINATION
		lib/gtk-2.0
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${PONYPROG_MACPORTS_DIR}/lib/gtk-2.0/modules
	DESTINATION
		lib/gtk-2.0/2.10.0
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${PONYPROG_MACPORTS_DIR}/lib/pango
	DESTINATION
		lib
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${PONYPROG_MACPORTS_DIR}/etc/gtk-2.0
		${PONYPROG_MACPORTS_DIR}/etc/fonts
		${PONYPROG_MACPORTS_DIR}/etc/pango
	DESTINATION
		etc
	)

# Bundle packaging is always available ...
ADD_SUBDIRECTORY(bundle)

# We optionally support creating packagemaker packages ...
IF(PONYPROG_CREATE_PACKAGEMAKER_PACKAGE)
	ADD_SUBDIRECTORY(packagemaker)
ENDIF(PONYPROG_CREATE_PACKAGEMAKER_PACKAGE)


# INCLUDE(CPack)
