=== debian/changelog ===
ponyprog (3.1.4+ds-2) unstable; urgency=medium

  * Team Upload
  * [b41abb1] d/control: Remove myself from Uploaders field

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 01 Nov 2025 08:48:03 +0200

ponyprog (3.1.4+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113417)

 -- Adrian Bunk <bunk@debian.org>  Sun, 26 Oct 2025 12:09:39 +0200

ponyprog (3.1.4+ds-1) unstable; urgency=medium

  * [320247f] New upstream version 3.1.4+ds
  * [303c208] d/control: Bump Standards-Version to 4.7.2
    No further changes needed.
  * [795e444] Rebuild patch queue from patch-queue branch
    Adjusted/updated patch:
    udev-adding-TAG-uaccess-so-users-can-access-the-device.patch
  * [7acb2c1] d/copyright: Update copyright years

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 23 Mar 2025 15:34:42 +0200
